export default class Tileset {
  constructor(json, name) {
    this.json = json
    this.name = name
  }

  get imagesToLoad() {
    const image = {}
    image[`${this.name}-image`] = this.json.image
    return image
  }

  populateImage(assets) {
    this.image = assets.get(`${this.name}-image`)
  }

  get tileWidth() {
    return this.json.tilewidth
  }

  get tileHeight() {
    return this.json.tileheight
  }

  get columns() {
    return this.json.columns
  }

  tileOffset(index) {
    return [
      ((index % this.columns) * this.tileWidth),
      (Math.floor(index / this.columns) * this.tileHeight)
    ]
  }
}
