const SQRT_OF_TWO = Math.sqrt(2)

const isZeroVector = vector => !vector.x && !vector.y

const doRectanglesOverlap = (rect1, rect2) => {
  return (
    doLengthsOverlap({ x: rect1.x, width: rect1.width }, { x: rect2.x, width: rect2.width })
      &&
      doLengthsOverlap({ x: rect1.y, width: rect1.height }, { x: rect2.y, width: rect2.height })
  )      
}

const doLengthsOverlap = (l1, l2) => {
  return !((l1.x + l1.width < l2.x) || (l2.x + l2.width) < l1.x)
}

export {
  SQRT_OF_TWO,
  isZeroVector,
  doRectanglesOverlap
}
